<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_IntCodeAttr3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_IntCodeAttr3 extends AbstractStructArrayBase
{
    /**
     * The Board
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_IntCodeAttr[]
     */
    public $Board;
    /**
     * Constructor method for ArrayOfJPSOAP_IntCodeAttr3
     * @uses ArrayOfJPSOAP_IntCodeAttr3::setBoard()
     * @param \StructType\JPSOAP_IntCodeAttr[] $board
     */
    public function __construct(array $board = array())
    {
        $this
            ->setBoard($board);
    }
    /**
     * Get Board value
     * @return \StructType\JPSOAP_IntCodeAttr[]|null
     */
    public function getBoard()
    {
        return $this->Board;
    }
    /**
     * This method is responsible for validating the values passed to the setBoard method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBoard method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBoardForArrayConstraintsFromSetBoard(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_IntCodeAttr3BoardItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_IntCodeAttr3BoardItem instanceof \StructType\JPSOAP_IntCodeAttr) {
                $invalidValues[] = is_object($arrayOfJPSOAP_IntCodeAttr3BoardItem) ? get_class($arrayOfJPSOAP_IntCodeAttr3BoardItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_IntCodeAttr3BoardItem), var_export($arrayOfJPSOAP_IntCodeAttr3BoardItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Board property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Board value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr[] $board
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr3
     */
    public function setBoard(array $board = array())
    {
        // validation for constraint: array
        if ('' !== ($boardArrayErrorMessage = self::validateBoardForArrayConstraintsFromSetBoard($board))) {
            throw new \InvalidArgumentException($boardArrayErrorMessage, __LINE__);
        }
        $this->Board = $board;
        return $this;
    }
    /**
     * Add item to Board value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr $item
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr3
     */
    public function addToBoard(\StructType\JPSOAP_IntCodeAttr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_IntCodeAttr) {
            throw new \InvalidArgumentException(sprintf('The Board property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Board[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Board
     */
    public function getAttributeName()
    {
        return 'Board';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
